package net.ibizsys.central.plugin.boot.core.service;

import net.ibizsys.central.dataentity.IDataEntityRuntime;
import net.ibizsys.central.dataentity.IDataEntityRuntimeContext;
import net.ibizsys.central.plugin.boot.core.domain.BaseData;
import net.ibizsys.central.plugin.boot.core.filter.BaseFilter;
import net.ibizsys.central.plugin.boot.core.helper.StringAdvUtils;
import net.ibizsys.central.plugin.boot.core.runtime.IBootService;
import net.ibizsys.central.plugin.boot.core.runtime.IBootSystemRuntime;
import net.ibizsys.model.dataentity.action.IPSDEAction;
import net.ibizsys.model.dataentity.ds.IPSDEDataSet;
import org.springframework.data.domain.Page;

import java.io.Serializable;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

public interface IServiceApiService<T extends BaseData, F extends BaseFilter> extends IBaseService<T,F>{




    default Object onRealAction(String strActionName,Object arg)  throws Throwable{
        return this.getDataEntityRuntimeContext().executeActionReal(strActionName, null, new Object[]{arg}, null);
    }


    default Object onRealFetch(String dsName,F arg) throws Throwable{
        return this.getDataEntityRuntimeContext().fetchDataSetReal("DEFAULT", arg.getDataSet(), new Object[]{arg}, null);
    }



    default <K extends Serializable> T onGet(K key) throws Throwable {
        return (T)onRealAction("Get",key);
    }


    default T onGetDraft(T dto) throws Throwable {
        return (T)onRealAction("GetDraft",dto);
    }


    default Integer onCheckKey(T dto) throws Throwable {
        return (Integer) onRealAction("CheckKey",dto);
    }


    default Page<T> onFetchDefault(F dto) throws Throwable {
        return (Page) onRealFetch("DEFAULT",dto);
    }

    default List<T> selectDefault(F dto) throws Throwable {
        return (List)this.getRuntimeService().getDataEntityRuntime().selectDataQuery("DEFAULT", dto);
    }

    default List<T> selectSimple(F dto) throws Throwable {
        return (List)this.getRuntimeService().getDataEntityRuntime().selectDataQuery("SIMPLE", dto);
    }

    default List<T> selectView(F dto) throws Throwable {
        return (List)this.getRuntimeService().getDataEntityRuntime().selectDataQuery("VIEW", dto);
    }

}
